#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "wx/resource.h"
#include "wx/valgen.h"
#include "wx/xrc/xmlres.h"

#include "option.h"

class DisasmOptionsDlg: public wxDialog
{
public:
	DisasmOptionsDlg(wxWindow *parent,DisasmOptionsRead::Results& res);
	void OnCheck(wxCommandEvent& event);
private:
	DisasmOptionsRead::Results& results;
	wxCheckBox *chkP3,*chk3DNow,*chkEnh3DNow,*chkAthlon;
	static bool resLoaded;

	DECLARE_EVENT_TABLE();
};

BEGIN_EVENT_TABLE(DisasmOptionsDlg, wxDialog)
	EVT_CHECKBOX(-1, DisasmOptionsDlg::OnCheck)
END_EVENT_TABLE()

DisasmOptionsDlg::DisasmOptionsDlg(wxWindow *parent,
		DisasmOptionsRead::Results& res)
	: results(res)
{
	// load resource
	wxTheXmlResource->LoadDialog(this, parent, "dlgOption");
	CentreOnParent();
	
	// init controls
	chkP3 = (wxCheckBox*)FindWindow("chkP3");
	chkP3->SetValidator(wxGenericValidator(&results.enableP3));
	
	chk3DNow = (wxCheckBox*)FindWindow("chk3D");
	chk3DNow->SetValidator(wxGenericValidator(&results.enable3DNow));
	
	chkEnh3DNow = (wxCheckBox*)FindWindow("chkEnh3D");
	chkEnh3DNow->SetValidator(wxGenericValidator(&results.enableEnh3DNow));
	
	chkAthlon = (wxCheckBox*)FindWindow("chkAthlon");
	chkAthlon->SetValidator(wxGenericValidator(&results.enableAthlon));

}

void DisasmOptionsDlg::OnCheck(wxCommandEvent& event)
{
	if ( event.GetEventObject() == chk3DNow )
	{
		if ( !event.IsChecked() )
			chkEnh3DNow->SetValue(false);
	}
	if ( event.GetEventObject() == chkEnh3DNow )
	{
		if ( event.IsChecked() )
			chk3DNow->SetValue(true);
	}
}

bool DisasmOptionsRead::Read(wxWindow* parent,Results& result)
{
	wxDialog *dlg = new DisasmOptionsDlg(parent,result);
	bool res = (dlg->ShowModal() == wxID_OK);
	dlg->Close(TRUE);
	return res;
}

