/*
PeRdr - PE file disassembler
Copyright (C) 1999-2002 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#include "global.h"
#pragma hdrstop

#include <stdexcept>
#include "x86istr.h"
#include "x86dasm.h"
#ifdef DEBUG
#include <cctype>
#endif
#include "utils/f77auto_ptr"

using namespace std;

void WriteInstruction(const Instruction& instruction)
{
  char buffer[80];
  instruction.Write(buffer);
  printf("%s\n",buffer);
}

class DataReaderTest: public DataReader
{
	vma_t start;
	const unsigned char* data;
	void ReadNext() { throw OutOfAddress(start + (ptr-data)); }
public:
	DataReaderTest(vma_t address,const unsigned char* code,size_t len):
		DataReader(code,code+len),start(address),data(code)
	{}
	void UnReadU8() { --ptr; }
	vma_t Tell() { return start + (ptr - data); }
};

int GetInstruction(vma_t address,const unsigned char* code,size_t len,Instruction& instruction)
{
  // legge l'istruzione
	RelocationInfos rels;
  InstructionDecoder decoder(rels);
	DataReaderTest reader(address, code, len);
  return decoder.Decode(instruction,reader);
}

int main()
{
  Instruction instr;

  if (GetInstruction(0x401000,(unsigned char*)"pippo",5,instr))
    WriteInstruction(instr);

  if (GetInstruction(0x401000,(unsigned char*)"\x0f\xb6\x40\x83",4,instr))
    WriteInstruction(instr);

  if (GetInstruction(0x401000,(unsigned char*)"\x0f\xb7\x40\x83",4,instr))
    WriteInstruction(instr);

  if (GetInstruction(0x401000,(unsigned char*)"\x0f\xbe\xc1",3,instr))
    WriteInstruction(instr);

  return 0;
}
